/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the CreateCveRecordRejectionResponseCreatedContainersCna type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateCveRecordRejectionResponseCreatedContainersCna{}

// CreateCveRecordRejectionResponseCreatedContainersCna struct for CreateCveRecordRejectionResponseCreatedContainersCna
type CreateCveRecordRejectionResponseCreatedContainersCna struct {
	RejectedReasons []CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner `json:"rejectedReasons,omitempty"`
	ReplacedBy []string `json:"replacedBy,omitempty"`
	ProviderMetadata *CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata `json:"providerMetadata,omitempty"`
}

// NewCreateCveRecordRejectionResponseCreatedContainersCna instantiates a new CreateCveRecordRejectionResponseCreatedContainersCna object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateCveRecordRejectionResponseCreatedContainersCna() *CreateCveRecordRejectionResponseCreatedContainersCna {
	this := CreateCveRecordRejectionResponseCreatedContainersCna{}
	return &this
}

// NewCreateCveRecordRejectionResponseCreatedContainersCnaWithDefaults instantiates a new CreateCveRecordRejectionResponseCreatedContainersCna object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateCveRecordRejectionResponseCreatedContainersCnaWithDefaults() *CreateCveRecordRejectionResponseCreatedContainersCna {
	this := CreateCveRecordRejectionResponseCreatedContainersCna{}
	return &this
}

// GetRejectedReasons returns the RejectedReasons field value if set, zero value otherwise.
func (o *CreateCveRecordRejectionResponseCreatedContainersCna) GetRejectedReasons() []CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner {
	if o == nil || IsNil(o.RejectedReasons) {
		var ret []CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner
		return ret
	}
	return o.RejectedReasons
}

// GetRejectedReasonsOk returns a tuple with the RejectedReasons field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCna) GetRejectedReasonsOk() ([]CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner, bool) {
	if o == nil || IsNil(o.RejectedReasons) {
		return nil, false
	}
	return o.RejectedReasons, true
}

// HasRejectedReasons returns a boolean if a field has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCna) HasRejectedReasons() bool {
	if o != nil && !IsNil(o.RejectedReasons) {
		return true
	}

	return false
}

// SetRejectedReasons gets a reference to the given []CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner and assigns it to the RejectedReasons field.
func (o *CreateCveRecordRejectionResponseCreatedContainersCna) SetRejectedReasons(v []CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) {
	o.RejectedReasons = v
}

// GetReplacedBy returns the ReplacedBy field value if set, zero value otherwise.
func (o *CreateCveRecordRejectionResponseCreatedContainersCna) GetReplacedBy() []string {
	if o == nil || IsNil(o.ReplacedBy) {
		var ret []string
		return ret
	}
	return o.ReplacedBy
}

// GetReplacedByOk returns a tuple with the ReplacedBy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCna) GetReplacedByOk() ([]string, bool) {
	if o == nil || IsNil(o.ReplacedBy) {
		return nil, false
	}
	return o.ReplacedBy, true
}

// HasReplacedBy returns a boolean if a field has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCna) HasReplacedBy() bool {
	if o != nil && !IsNil(o.ReplacedBy) {
		return true
	}

	return false
}

// SetReplacedBy gets a reference to the given []string and assigns it to the ReplacedBy field.
func (o *CreateCveRecordRejectionResponseCreatedContainersCna) SetReplacedBy(v []string) {
	o.ReplacedBy = v
}

// GetProviderMetadata returns the ProviderMetadata field value if set, zero value otherwise.
func (o *CreateCveRecordRejectionResponseCreatedContainersCna) GetProviderMetadata() CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata {
	if o == nil || IsNil(o.ProviderMetadata) {
		var ret CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata
		return ret
	}
	return *o.ProviderMetadata
}

// GetProviderMetadataOk returns a tuple with the ProviderMetadata field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCna) GetProviderMetadataOk() (*CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata, bool) {
	if o == nil || IsNil(o.ProviderMetadata) {
		return nil, false
	}
	return o.ProviderMetadata, true
}

// HasProviderMetadata returns a boolean if a field has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCna) HasProviderMetadata() bool {
	if o != nil && !IsNil(o.ProviderMetadata) {
		return true
	}

	return false
}

// SetProviderMetadata gets a reference to the given CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata and assigns it to the ProviderMetadata field.
func (o *CreateCveRecordRejectionResponseCreatedContainersCna) SetProviderMetadata(v CreateCveRecordRejectionResponseCreatedContainersCnaProviderMetadata) {
	o.ProviderMetadata = &v
}

func (o CreateCveRecordRejectionResponseCreatedContainersCna) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateCveRecordRejectionResponseCreatedContainersCna) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.RejectedReasons) {
		toSerialize["rejectedReasons"] = o.RejectedReasons
	}
	if !IsNil(o.ReplacedBy) {
		toSerialize["replacedBy"] = o.ReplacedBy
	}
	if !IsNil(o.ProviderMetadata) {
		toSerialize["providerMetadata"] = o.ProviderMetadata
	}
	return toSerialize, nil
}

type NullableCreateCveRecordRejectionResponseCreatedContainersCna struct {
	value *CreateCveRecordRejectionResponseCreatedContainersCna
	isSet bool
}

func (v NullableCreateCveRecordRejectionResponseCreatedContainersCna) Get() *CreateCveRecordRejectionResponseCreatedContainersCna {
	return v.value
}

func (v *NullableCreateCveRecordRejectionResponseCreatedContainersCna) Set(val *CreateCveRecordRejectionResponseCreatedContainersCna) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateCveRecordRejectionResponseCreatedContainersCna) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateCveRecordRejectionResponseCreatedContainersCna) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateCveRecordRejectionResponseCreatedContainersCna(val *CreateCveRecordRejectionResponseCreatedContainersCna) *NullableCreateCveRecordRejectionResponseCreatedContainersCna {
	return &NullableCreateCveRecordRejectionResponseCreatedContainersCna{value: val, isSet: true}
}

func (v NullableCreateCveRecordRejectionResponseCreatedContainersCna) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateCveRecordRejectionResponseCreatedContainersCna) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


